Index: issm/trunk/src/c/classes/Loads/Friction.h
===================================================================
--- issm/trunk/src/c/classes/Loads/Friction.h	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Friction.h	(revision 26744)
@@ -14,11 +14,17 @@
 
 	public:
-		Element* element;
-		int      dim;
-		int      law;
+		Element    *element;
+		int         law;
+		int         domaintype;
+		IssmDouble  apply_dim;
+		Input      *vx_input;
+		Input      *vy_input;
+		Input      *vz_input;
 
 		/*methods: */
 		Friction();
-		Friction(Element* element_in,int dim_in);
+		Friction(Element* element_in);
+		Friction(Element* element_in, int dim);
+		Friction(Element* element_in, IssmDouble dim);
 		~Friction();
 
@@ -32,4 +38,5 @@
 		void  GetAlpha2(IssmDouble* palpha2,Gauss* gauss);
 		void  GetAlpha2Coulomb(IssmDouble* palpha2,Gauss* gauss);
+		void  GetAlpha2Coulomb2(IssmDouble* palpha2,Gauss* gauss);
 		void  GetAlpha2Hydro(IssmDouble* palpha2,Gauss* gauss);
 		void  GetAlpha2Josh(IssmDouble* palpha2,Gauss* gauss);
@@ -45,5 +52,10 @@
 
 		IssmDouble EffectivePressure(Gauss* gauss);
+		IssmDouble IcePressure(Gauss* gauss);
+		IssmDouble SubglacialWaterPressure(Gauss* gauss);
 		IssmDouble VelMag(Gauss* gauss);
+		void GetBasalSlidingSpeeds(IssmDouble* pvx, Gauss* gauss);
+		void GetBasalSlidingSpeeds(IssmDouble* pvx, IssmDouble* pvy, Gauss* gauss);
+		void GetBasalSlidingSpeeds(IssmDouble* pvx, IssmDouble* pvy, IssmDouble* pvz, Gauss* gauss);
 };
 
Index: issm/trunk/src/c/classes/Loads/Moulin.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Moulin.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Moulin.cpp	(revision 26744)
@@ -291,5 +291,5 @@
 		switch(set2_enum){
 			case FsetEnum:
-				if(node->fsize){
+				if(node->FSize()){
 					if(this->node->IsClone())
 					 o_nz += 1;
@@ -307,5 +307,5 @@
 				break;
 			case SsetEnum:
-				if(node->ssize){
+				if(node->SSize()){
 					if(this->node->IsClone())
 					 o_nz += 1;
Index: issm/trunk/src/c/classes/Loads/Neumannflux.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Neumannflux.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Neumannflux.cpp	(revision 26744)
@@ -306,5 +306,5 @@
 			switch(set2_enum){
 				case FsetEnum:
-					if(nodes[i]->fsize){
+					if(nodes[i]->FSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -322,5 +322,5 @@
 					break;
 				case SsetEnum:
-					if(nodes[i]->ssize){
+					if(nodes[i]->SSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -354,5 +354,5 @@
 	Tria*  tria=(Tria*)element;
 	_assert_(tria->FiniteElement()==P1Enum); 
-	if(!tria->IsIceInElement() || tria->IsFloating()) return NULL;
+	if(!tria->IsIceInElement() || tria->IsAllFloating()) return NULL;
 
 	/*Initialize Element vector and other vectors*/
@@ -396,5 +396,5 @@
 	Tria*  tria=(Tria*)element;
 	_assert_(tria->FiniteElement()==P1Enum); 
-	if(!tria->IsIceInElement() || tria->IsFloating()) return NULL;
+	if(!tria->IsIceInElement() || tria->IsAllFloating()) return NULL;
 
 	/*Initialize Element vector and other vectors*/
Index: issm/trunk/src/c/classes/Loads/Numericalflux.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Numericalflux.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Numericalflux.cpp	(revision 26744)
@@ -430,5 +430,5 @@
 			switch(set2_enum){
 				case FsetEnum:
-					if(nodes[i]->fsize){
+					if(nodes[i]->FSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -446,5 +446,5 @@
 					break;
 				case SsetEnum:
-					if(nodes[i]->ssize){
+					if(nodes[i]->SSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
Index: issm/trunk/src/c/classes/Loads/Pengrid.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Pengrid.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Pengrid.cpp	(revision 26744)
@@ -294,5 +294,5 @@
 		switch(set2_enum){
 			case FsetEnum:
-				if(node->fsize){
+				if(node->FSize()){
 					if(this->node->IsClone())
 					 o_nz += 1;
@@ -310,5 +310,5 @@
 				break;
 			case SsetEnum:
-				if(node->ssize){
+				if(node->SSize()){
 					if(this->node->IsClone())
 					 o_nz += 1;
Index: issm/trunk/src/c/classes/Loads/Penpair.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Penpair.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Penpair.cpp	(revision 26744)
@@ -235,5 +235,5 @@
 			switch(set2_enum){
 				case FsetEnum:
-					if(nodes[i]->fsize){
+					if(nodes[i]->FSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -251,5 +251,5 @@
 					break;
 				case SsetEnum:
-					if(nodes[i]->ssize){
+					if(nodes[i]->SSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -355,4 +355,14 @@
 				default: _error_("Approximation "<<EnumToStringx(approximation1)<<" not supported yet");
 			}
+		case MLHOApproximationEnum:
+			switch(approximation1){
+				case MLHOApproximationEnum:   return PenaltyCreateKMatrixStressbalanceSSAHO(kmax); 
+				default: _error_("Approximation "<<EnumToStringx(approximation1)<<" not supported yet");
+			}
+		case L1L2ApproximationEnum:
+			switch(approximation1){
+				case L1L2ApproximationEnum:   return PenaltyCreateKMatrixStressbalanceSSAHO(kmax); 
+				default: _error_("Approximation "<<EnumToStringx(approximation1)<<" not supported yet");
+			}
 		case FSvelocityEnum:
 			switch(approximation1){
Index: issm/trunk/src/c/classes/Loads/Riftfront.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Riftfront.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Loads/Riftfront.cpp	(revision 26744)
@@ -392,5 +392,5 @@
 			switch(set2_enum){
 				case FsetEnum:
-					if(nodes[i]->fsize){
+					if(nodes[i]->FSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -408,5 +408,5 @@
 					break;
 				case SsetEnum:
-					if(nodes[i]->ssize){
+					if(nodes[i]->SSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
Index: issm/trunk/src/c/classes/Massfluxatgate.h
===================================================================
--- issm/trunk/src/c/classes/Massfluxatgate.h	(revision 25994)
+++ issm/trunk/src/c/classes/Massfluxatgate.h	(revision 26744)
@@ -32,11 +32,15 @@
 		Massfluxatgate(){/*{{{*/
 			this->definitionenum        = -1;
-			this->name        = 0;
+			this->name        = NULL;
 			this->numsegments = 0;
-			this->segments    = 0;
+			this->elements    = NULL;
+			this->x1				= NULL;
+			this->x2				= NULL;
+			this->y1				= NULL;
+			this->y2				= NULL;
 		}
 		/*}}}*/
 		Massfluxatgate(char* in_name, int in_definitionenum, int in_numsegments, doubletype* in_segments) {/*{{{*/
-			
+
 			int i;
 
@@ -79,5 +83,5 @@
 				this->y2=xNew<doubletype>(this->numsegments); xMemCpy<doubletype>(this->y2,in_y2,this->numsegments);
 				this->elements=xNew<int>(this->numsegments); xMemCpy<int>(this->elements,in_elements,this->numsegments);
-				
+
 			}
 		}
Index: issm/trunk/src/c/classes/Materials/Material.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Material.h	(revision 25994)
+++ issm/trunk/src/c/classes/Materials/Material.h	(revision 26744)
@@ -51,4 +51,6 @@
 		virtual void       ViscosityFS(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vz_input)=0;
 		virtual void       ViscosityHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input)=0;
+		virtual void       ViscosityMLHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input)=0;
+		virtual void       ViscosityMLHOAdjoint(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input)=0;
 		virtual void       ViscosityL1L2(IssmDouble* pviscosity,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* surf)=0;
 		virtual void       ViscositySSA(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input)=0;
Index: issm/trunk/src/c/classes/Materials/Matestar.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Matestar.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Materials/Matestar.cpp	(revision 26744)
@@ -567,4 +567,10 @@
 	*pviscosity=GetViscosityGeneral(vx,vy,vz,&dvx[0],&dvy[0],&dvz[0],eps_eff,isdepthaveraged,gauss);
 }/*}}}*/
+void  Matestar::ViscosityMLHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input){/*{{{*/
+	_error_("not implemented yet");
+}/*}}}*/
+void  Matestar::ViscosityMLHOAdjoint(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input){/*{{{*/
+	_error_("not implemented yet");
+}/*}}}*/
 void  Matestar::ViscosityL1L2(IssmDouble* pviscosity,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* surface_input){/*{{{*/
 	_error_("not implemented yet");
Index: issm/trunk/src/c/classes/Materials/Matestar.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Matestar.h	(revision 25994)
+++ issm/trunk/src/c/classes/Materials/Matestar.h	(revision 26744)
@@ -28,5 +28,4 @@
 		Hook    *helement;
 		Element *element;
-		int      rheology_law;
 
 	public:
@@ -77,4 +76,6 @@
 		void       ViscosityFS(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vz_input);
 		void       ViscosityHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input);
+		void       ViscosityMLHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input);
+		void       ViscosityMLHOAdjoint(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input);
 		void       ViscosityL1L2(IssmDouble* pviscosity,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* surf);
 		void       ViscositySSA(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input);
Index: issm/trunk/src/c/classes/Materials/Matice.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Matice.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Materials/Matice.cpp	(revision 26744)
@@ -292,10 +292,10 @@
 }
 /*}}}*/
-bool Matice::IsDamage(){/*{{{*/
+bool       Matice::IsDamage(){/*{{{*/
 
 	return this->isdamaged;
 }
 /*}}}*/
-bool Matice::IsEnhanced(){/*{{{*/
+bool       Matice::IsEnhanced(){/*{{{*/
 
 	return this->isenhanced;
@@ -736,4 +736,133 @@
 	*pviscosity=viscosity;
 }/*}}}*/
+void  Matice::ViscosityMLHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vxbase_input,Input* vybase_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input){/*{{{*/
+
+	/*Intermediaries*/
+	IssmDouble epsilon[5];	/* epsilon=[exx,eyy,exy,exz,eyz]; */
+	IssmDouble epsilon_eff;
+	IssmDouble zeta,H,n;
+	IssmDouble f[4],F[4];
+	IssmDouble mubar[4];
+	IssmDouble mu;
+	int order=5; 
+
+	for(int i=0;i<4;++i) mubar[i]=0;
+
+	GaussSeg* gauss_seg=new GaussSeg(order);
+	//IssmDouble eps_eff_averaged=0;
+	while(gauss_seg->next()){
+
+		/*Compute zeta for gauss_seg point (0=surface, 1=base)*/
+		zeta=0.5*(gauss_seg->coord1+1);	
+
+		/* eps_eff^2 = exx^2 + eyy^2 + exy^2 + exz^2 + eyz^2 + exx*eyy (for a given zeta)*/
+		element->StrainRateMLHO(&epsilon[0],xyz_list,gauss,
+						vxbase_input,vybase_input,vxshear_input,vyshear_input,thickness_input,n_input,zeta);
+		epsilon_eff=sqrt(epsilon[0]*epsilon[0] + epsilon[1]*epsilon[1] + epsilon[2]*epsilon[2] 
+						  +  epsilon[3]*epsilon[3] + epsilon[4]*epsilon[4] + epsilon[0]*epsilon[1]);
+
+		/*Get viscosity at zeta */
+//?? need to use Bar for the current inversion
+//    this->GetViscosity(&mu,epsilon_eff,gauss);
+		this->GetViscosityBar(&mu, epsilon_eff,gauss);
+		thickness_input->GetInputValue(&H, gauss);
+      n_input->GetInputValue(&n,gauss);
+
+		/*Compute fi and Fi at zeta*/
+		f[0]=1;
+		f[1]=(1-pow(zeta,n+1));
+		f[2]=(1-pow(zeta,n+1))*(1-pow(zeta,n+1));
+		f[3]=((n+1)/H)*pow(zeta,n) * ((n+1)/H)*pow(zeta,n);
+
+		F[0]=H;
+		F[1]=H*(n+1)/(n+2);
+		F[2]=2*H*(n+1)*(n+1)/( (2*n+3)*(n+2) );
+		F[3]=(n+1)*(n+1)/( H*(2*n+1) );
+
+		/*Sum the viscosity*/
+		mubar[0]+=(H/(2*F[0]))*gauss_seg->weight*mu*f[0];
+		mubar[1]+=(H/(2*F[1]))*gauss_seg->weight*mu*f[1];
+		mubar[2]+=(H/(2*F[2]))*gauss_seg->weight*mu*f[2];
+		mubar[3]+=(H/(2*F[3]))*gauss_seg->weight*mu*f[3];
+
+	}//while
+
+	/*Assign output pointer*/
+	pviscosity[0]=mubar[0];
+	pviscosity[1]=mubar[1];
+	pviscosity[2]=mubar[2];
+	pviscosity[3]=mubar[3];
+
+	/*Clean up*/
+	delete gauss_seg;
+}/*}}}*/
+void  Matice::ViscosityMLHOAdjoint(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vxbase_input,Input* vybase_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input){/*{{{*/
+
+	/* To compute the additional 5 terms in the viscosity appear in the adjoint equation*/
+	/*Intermediaries*/
+	IssmDouble epsilon[5];	/* epsilon=[exx,eyy,exy,exz,eyz]; */
+	IssmDouble epsilon_eff;
+	IssmDouble zeta,H,n;
+	IssmDouble f[9],F[9];
+	IssmDouble mubar[9];
+	IssmDouble mu;
+	int order=10; 
+
+	for(int i=0;i<9;++i) mubar[i]=0;
+
+	GaussSeg* gauss_seg=new GaussSeg(order);
+	//IssmDouble eps_eff_averaged=0;
+	while(gauss_seg->next()){
+		
+		/*Compute zeta for gauss_seg point (0=surface, 1=base)*/
+		zeta=0.5*(gauss_seg->coord1+1);	
+
+		/* eps_eff^2 = exx^2 + eyy^2 + exy^2 + exz^2 + eyz^2 + exx*eyy (for a given zeta)*/
+		element->StrainRateMLHO(&epsilon[0],xyz_list,gauss,
+						vxbase_input,vybase_input,vxshear_input,vyshear_input,thickness_input,n_input,zeta);
+		epsilon_eff=sqrt(epsilon[0]*epsilon[0] + epsilon[1]*epsilon[1] + epsilon[2]*epsilon[2] 
+						  +  epsilon[3]*epsilon[3] + epsilon[4]*epsilon[4] + epsilon[0]*epsilon[1]);
+
+		this->GetViscosity(&mu,epsilon_eff,gauss);
+		/*the adjoint viscosity with zeta dependent term*/
+		mu = mu /epsilon_eff/epsilon_eff;
+
+		thickness_input->GetInputValue(&H, gauss);
+      n_input->GetInputValue(&n,gauss);
+
+		/*Compute fi and Fi at zeta*/
+		f[0]=1;
+		f[1]=(1-pow(zeta,n+1));
+		f[2]=(1-pow(zeta,n+1))*(1-pow(zeta,n+1));
+		f[3]=pow(zeta,2*n); // NOTE: this is different from the forward formulation
+		f[4]=(1-pow(zeta,n+1))*(1-pow(zeta,n+1))*(1-pow(zeta,n+1));
+		f[5]=(1-pow(zeta,n+1))*(1-pow(zeta,n+1))*(1-pow(zeta,n+1))*(1-pow(zeta,n+1));
+		f[6]=(1-pow(zeta,n+1))*pow(zeta,2*n);
+		f[7]=(1-pow(zeta,n+1))*(1-pow(zeta,n+1))*pow(zeta,2*n);
+		f[8]=pow(zeta,4*n);
+
+	
+		F[0]=H;
+		F[1]=H*(n+1)/(n+2);
+		F[2]=2*H*(n+1)*(n+1)/( (2*n+3)*(n+2) );
+		F[3]=H/(2*n+1);
+		F[4]=6*H*(n+1)*(n+1)*(n+1)/( (n+2)*(2*n+3)*(3*n+4) );
+		F[5]=24*H*(n+1)*(n+1)*(n+1)*(n+1)/( (n+2)*(2*n+3)*(3*n+4)*(4*n+5) );
+		F[6]=H*(n+1)/( (2*n+1)*(3*n+2) );
+		F[7]=2*H*(n+1)*(n+1)/( (2*n+1)*(3*n+2)*(4*n+3) );
+		F[8]=H/(4*n+1);
+
+		/*Sum the viscosity*/
+		for(int i=0;i<9;i++) {
+			mubar[i]+=(H/2)*gauss_seg->weight*mu*f[i];
+		}
+	}//while
+
+	/*Assign output pointer*/
+	for(int i=0;i<9;i++) pviscosity[i]=mubar[i];
+
+	/*Clean up*/
+	delete gauss_seg;
+}/*}}}*/
 void  Matice::ViscosityL1L2(IssmDouble* pviscosity,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* surface_input){/*{{{*/
 	/*Compute the L1L2 viscosity
Index: issm/trunk/src/c/classes/Materials/Matice.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Matice.h	(revision 25994)
+++ issm/trunk/src/c/classes/Materials/Matice.h	(revision 26744)
@@ -28,5 +28,4 @@
 		bool     isdamaged;
 		bool     isenhanced;
-		int      rheology_law;
 		Hook    *helement;
 		Element *element;
@@ -79,4 +78,6 @@
 		void       ViscosityFS(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vz_input);
 		void       ViscosityHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input);
+		void       ViscosityMLHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input);
+		void       ViscosityMLHOAdjoint(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input);
 		void       ViscosityL1L2(IssmDouble* pviscosity,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* surf);
 		void       ViscositySSA(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input);
Index: issm/trunk/src/c/classes/Materials/Matlitho.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Matlitho.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Materials/Matlitho.cpp	(revision 26744)
@@ -21,6 +21,10 @@
 	this->burgers_viscosity=NULL;
 	this->burgers_mu=NULL;
+	this->ebm_alpha=NULL;
+	this->ebm_delta=NULL;	
+	this->ebm_taul=NULL;
+	this->ebm_tauh=NULL;
 	this->density=NULL;
-	this->isburgers=NULL;
+	this->rheologymodel=NULL;
 	this->issolid=NULL;
 	return;
@@ -29,5 +33,5 @@
 Matlitho::Matlitho(int matlitho_mid, IoModel* iomodel){/*{{{*/
 
-	IssmDouble* isburgersd=NULL;
+	IssmDouble* rheologymodeld=NULL;
 	IssmDouble* issolidd=NULL;
 
@@ -53,17 +57,29 @@
 	xMemCpy<IssmDouble>(this->burgers_mu, iomodel->Data("md.materials.burgers_mu"),this->numlayers);
 
+	this->ebm_alpha=xNew<IssmDouble>(this->numlayers);
+	xMemCpy<IssmDouble>(this->ebm_alpha, iomodel->Data("md.materials.ebm_alpha"),this->numlayers);
+
+	this->ebm_delta=xNew<IssmDouble>(this->numlayers);
+	xMemCpy<IssmDouble>(this->ebm_delta, iomodel->Data("md.materials.ebm_delta"),this->numlayers);
+
+	this->ebm_taul=xNew<IssmDouble>(this->numlayers);
+	xMemCpy<IssmDouble>(this->ebm_taul, iomodel->Data("md.materials.ebm_taul"),this->numlayers);
+
+	this->ebm_tauh=xNew<IssmDouble>(this->numlayers);
+	xMemCpy<IssmDouble>(this->ebm_tauh, iomodel->Data("md.materials.ebm_tauh"),this->numlayers);
+
 	this->density=xNew<IssmDouble>(this->numlayers);
 	xMemCpy<IssmDouble>(this->density, iomodel->Data("md.materials.density"),this->numlayers);
 
-	this->isburgers=xNew<IssmDouble>(this->numlayers);
-	xMemCpy<IssmDouble>(this->isburgers, iomodel->Data("md.materials.isburgers"),this->numlayers);
+	this->rheologymodel=xNew<IssmDouble>(this->numlayers);
+	xMemCpy<IssmDouble>(this->rheologymodel, iomodel->Data("md.materials.rheologymodel"),this->numlayers);
 
 	this->issolid=xNew<IssmDouble>(this->numlayers);
 	xMemCpy<IssmDouble>(this->issolid, iomodel->Data("md.materials.issolid"),this->numlayers);
 
-	/*isburgersd= xNew<IssmDouble>(this->numlayers);
-	this->isburgers=xNew<bool>(this->numlayers);
-	xMemCpy<IssmDouble>(isburgersd, iomodel->Data("md.materials.isburgers"),this->numlayers);
-	for (int i=0;i<this->numlayers;i++)this->isburgers[i]=reCast<bool,IssmDouble>(isburgersd[i]);
+	/*rheologymodeld= xNew<IssmDouble>(this->numlayers);
+	this->rheologymodel=xNew<bool>(this->numlayers);
+	xMemCpy<IssmDouble>(rheologymodeld, iomodel->Data("md.materials.rheologymodel"),this->numlayers);
+	for (int i=0;i<this->numlayers;i++)this->rheologymodel[i]=reCast<bool,IssmDouble>(rheologymodeld[i]);
 
 	issolidd= xNew<IssmDouble>(this->numlayers);
@@ -73,5 +89,5 @@
 
 	/*free ressources: */
-	xDelete<IssmDouble>(isburgersd);
+	xDelete<IssmDouble>(rheologymodeld);
 	xDelete<IssmDouble>(issolidd);
 }
@@ -85,6 +101,10 @@
 	xDelete<IssmDouble>(burgers_viscosity);
 	xDelete<IssmDouble>(burgers_mu);
+	xDelete<IssmDouble>(ebm_alpha);
+	xDelete<IssmDouble>(ebm_delta);
+	xDelete<IssmDouble>(ebm_taul);
+	xDelete<IssmDouble>(ebm_tauh);
 	xDelete<IssmDouble>(density);
-	xDelete<IssmDouble>(isburgers);
+	xDelete<IssmDouble>(rheologymodel);
 	xDelete<IssmDouble>(issolid);
 
@@ -116,8 +136,12 @@
 		matlitho->burgers_viscosity=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->burgers_viscosity, this->burgers_viscosity,this->numlayers);
 		matlitho->burgers_mu=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->burgers_mu, this->burgers_mu,this->numlayers);
+		matlitho->ebm_alpha=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->ebm_alpha, this->ebm_alpha,this->numlayers);
+		matlitho->ebm_delta=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->ebm_delta, this->ebm_delta,this->numlayers);
+		matlitho->ebm_taul=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->ebm_taul, this->ebm_taul,this->numlayers);
+		matlitho->ebm_tauh=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->ebm_tauh, this->ebm_tauh,this->numlayers);
 		matlitho->density=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->density, this->density,this->numlayers);
-		matlitho->isburgers=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->isburgers, this->isburgers,this->numlayers);
+		matlitho->rheologymodel=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->rheologymodel, this->rheologymodel,this->numlayers);
 		matlitho->issolid=xNew<IssmDouble>(this->numlayers); xMemCpy<IssmDouble>(matlitho->issolid, this->issolid,this->numlayers);
-		/*matlitho->isburgers=xNew<bool>(this->numlayers); for(int i=0;i<this->numlayers;i++)matlitho->isburgers[i]=this->isburgers[i]; 
+		/*matlitho->rheologymodel=xNew<bool>(this->numlayers); for(int i=0;i<this->numlayers;i++)matlitho->rheologymodel[i]=this->rheologymodel[i]; 
 		matlitho->issolid=xNew<bool>(this->numlayers); for(int i=0;i<this->numlayers;i++)matlitho->issolid[i]=this->issolid[i];*/ 
 	}
@@ -136,7 +160,7 @@
 	_printf_("   mid: " << mid << "\n");
 	_printf_("   numlayers: " << numlayers << "\n");
-	_printf_("layer radius viscosity lame_lambda lame_mu burgers_viscosity burgers_mu density isburgers issolid\n");
+	_printf_("layer radius viscosity lame_lambda lame_mu burgers_viscosity burgers_mu ebm_alpha ebm_delta ebm_taul ebm_tauh density rheologymodel issolid\n");
 	for (int i=0;i<numlayers;i++){
-		_printf_(i << " " << radius[i] << " " << viscosity[i] << " " << lame_lambda[i] << " " << lame_mu[i] << " " << burgers_viscosity[i] << " " << burgers_mu[i] << " " << density[i] << " " << isburgers[i] << " " << issolid[i]);
+		_printf_(i << " " << radius[i] << " " << viscosity[i] << " " << lame_lambda[i] << " " << lame_mu[i] << " " << burgers_viscosity[i] << " " << burgers_mu[i] << " " << ebm_alpha[i] << " " << ebm_delta[i] << " " << ebm_taul[i] << " " << ebm_tauh[i] << " " << density[i] << " " << rheologymodel[i] << " " << issolid[i]);
 	}
 	return;
@@ -158,6 +182,10 @@
 		marshallhandle->call(this->burgers_viscosity,numlayers);
 		marshallhandle->call(this->burgers_mu,numlayers);
+		marshallhandle->call(this->ebm_alpha,numlayers);
+		marshallhandle->call(this->ebm_delta,numlayers);
+		marshallhandle->call(this->ebm_taul,numlayers);
+		marshallhandle->call(this->ebm_tauh,numlayers);
 		marshallhandle->call(this->density,numlayers);
-		marshallhandle->call(this->isburgers,numlayers);
+		marshallhandle->call(this->rheologymodel,numlayers);
 		marshallhandle->call(this->issolid,numlayers);
 	}
@@ -169,6 +197,10 @@
 		burgers_viscosity = NULL;
 		burgers_mu        = NULL;
+		ebm_alpha         = NULL;
+		ebm_delta         = NULL;
+		ebm_taul          = NULL;
+		ebm_tauh          = NULL;
 		density           = NULL;
-		isburgers         = NULL;
+		rheologymodel     = NULL;
 		issolid           = NULL;
 	}
Index: issm/trunk/src/c/classes/Materials/Matlitho.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Matlitho.h	(revision 25994)
+++ issm/trunk/src/c/classes/Materials/Matlitho.h	(revision 26744)
@@ -23,6 +23,10 @@
 		IssmDouble*  burgers_viscosity;
 		IssmDouble*  burgers_mu;
+		IssmDouble*  ebm_alpha;
+		IssmDouble*  ebm_delta;
+		IssmDouble*  ebm_taul;
+		IssmDouble*  ebm_tauh;
 		IssmDouble*  density;
-		IssmDouble*  isburgers;
+		IssmDouble*  rheologymodel;
 		IssmDouble*  issolid;
 
@@ -68,4 +72,6 @@
 		void       ViscosityFS(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vz_input){_error_("not supported");};
 		void       ViscosityHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input){_error_("not supported");};
+		void       ViscosityMLHO(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input){_error_("not supported");};
+		void       ViscosityMLHOAdjoint(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input){_error_("not supported");};
 		void       ViscosityL1L2(IssmDouble* pviscosity,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input,Input* surf){_error_("not supported");};
 		void       ViscositySSA(IssmDouble* pviscosity,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input){_error_("not supported");};
